﻿//InDesign CS3/4
//alexey-denisjuk@ya.ru, 2009
str = 'Скрипт маскирует белым фоном на текущем развороте всё,\r кроме области под выделеным фреймом\r и экспортирует страницу (разворот) в .jpg (72, low) на рабочий стол';
conf= confirm(str);
if(!conf)
	exit();
var doc = app.activeDocument;
var box = app.selection[0];
if(!box){
	alert('Ничего не выделено!');
	exit();
	}
switch(box.constructor.name){
	case 'TextFrame':
	case 'Rectangle':
	break;
	default:
	alert('Такое выделение не поддерживается:\r'+box.constructor.name);
	exit();
	}
var spread = box.parent.parent;
if(spread.constructor.name != 'Spread')//если блок полностью вне страниц, или если блок встроен - прерываем
	exit();
var spreadSize = [spread.pages.lastItem().bounds[2], spread.pages.lastItem().bounds[3]];

for(var activeLayer = 0; activeLayer < doc.layers.length; activeLayer++)
	if(doc.layers[activeLayer] == doc.activeLayer)
		break;
doc.activeLayer = doc.layers.firstItem();

var rects = [];
var count = 0;
if(box.visibleBounds[0] > 0)
	rects[++count] = spread.rectangles.add({visibleBounds:[-5, -5, box.visibleBounds[0], spreadSize[1]+5], strokeWeight:5, fillColor: 'Paper'});
if(box.visibleBounds[1] > 0)
	rects[++count] = spread.rectangles.add({visibleBounds:[-5, -5, spreadSize[0]+5, box.visibleBounds[1]], strokeWeight:5, fillColor: 'Paper'});
if(box.visibleBounds[2] < spreadSize[0])
	rects[++count] = spread.rectangles.add({visibleBounds:[box.visibleBounds[2], -5, spreadSize[0]+5, spreadSize[1]+5], strokeWeight:5, fillColor: 'Paper'});
if(box.visibleBounds[3] < spreadSize[1])
	rects[++count] = spread.rectangles.add({visibleBounds:[-5, box.visibleBounds[3], spreadSize[0]+5, spreadSize[1]+5], strokeWeight:5, fillColor: 'Paper'});


file = File(Folder.desktop + '/' + doc.name + '_' + box.parent.name + '.jpg');
app.jpegExportPreferences.exportingSpread = (spread.pages.length > 1 && (spreadSize[1]/2 > box.visibleBounds[1] && spreadSize[1]/2 < box.visibleBounds[3])) ? true : false;
app.jpegExportPreferences.resolution = 72;
app.jpegExportPreferences.jpegQuality = JPEGOptionsQuality.low;
app.jpegExportPreferences.jpegExportRange = ExportRangeOrAllPages.EXPORT_RANGE;//1785742674
app.jpegExportPreferences.pageString = box.parent.name;
doc.exportFile(ExportFormat.jpg, file, false);

if(count)
	for(i = rects.length-1; i > 0 ; i--)
		rects[i].remove();
doc.activeLayer = doc.layers[activeLayer];